=== added file 'src/com/goldencode/p2j/ui/Calendar.java'
--- src/com/goldencode/p2j/ui/Calendar.java	1970-01-01 00:00:00 +0000
+++ src/com/goldencode/p2j/ui/Calendar.java	2020-02-25 16:18:50 +0000
@@ -0,0 +1,437 @@
+/*
+** Module   : Calendar.java
+** Abstract : Calendar widget interface.
+**
+** Copyright (c) 2020, Golden Code Development Corporation.
+**
+** -#- -I- --Date-- --------------------------------Description-----------------------------------
+** 001 SBI 20200114 Created initial version.
+*/
+
+/*
+** This program is free software: you can redistribute it and/or modify
+** it under the terms of the GNU Affero General Public License as
+** published by the Free Software Foundation, either version 3 of the
+** License, or (at your option) any later version.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+** GNU Affero General Public License for more details.
+**
+** You may find a copy of the GNU Affero GPL version 3 at the following
+** location: https://www.gnu.org/licenses/agpl-3.0.en.html
+** 
+** Additional terms under GNU Affero GPL version 3 section 7:
+** 
+**   Under Section 7 of the GNU Affero GPL version 3, the following additional
+**   terms apply to the works covered under the License.  These additional terms
+**   are non-permissive additional terms allowed under Section 7 of the GNU
+**   Affero GPL version 3 and may not be removed by you.
+** 
+**   0. Attribution Requirement.
+** 
+**     You must preserve all legal notices or author attributions in the covered
+**     work or Appropriate Legal Notices displayed by works containing the covered
+**     work.  You may not remove from the covered work any author or developer
+**     credit already included within the covered work.
+** 
+**   1. No License To Use Trademarks.
+** 
+**     This license does not grant any license or rights to use the trademarks
+**     Golden Code, FWD, any Golden Code or FWD logo, or any other trademarks
+**     of Golden Code Development Corporation. You are not authorized to use the
+**     name Golden Code, FWD, or the names of any author or contributor, for
+**     publicity purposes without written authorization.
+** 
+**   2. No Misrepresentation of Affiliation.
+** 
+**     You may not represent yourself as Golden Code Development Corporation or FWD.
+** 
+**     You may not represent yourself for publicity purposes as associated with
+**     Golden Code Development Corporation, FWD, or any author or contributor to
+**     the covered work, without written authorization.
+** 
+**   3. No Misrepresentation of Source or Origin.
+** 
+**     You may not represent the covered work as solely your work.  All modified
+**     versions of the covered work must be marked in a reasonable way to make it
+**     clear that the modified work is not originating from Golden Code Development
+**     Corporation or FWD.  All modified versions must contain the notices of
+**     attribution required in this license.
+*/
+
+package com.goldencode.p2j.ui;
+
+import com.goldencode.p2j.util.*;
+
+
+/**
+ * Defines exported methods and constants for the calendar widget.
+ */
+@LegacyResource(resource = LegacyResource.CALENDAR)
+public interface Calendar
+extends WrappedResource,
+        ComData,
+        OcxMouse,
+        OcxDragDrop,
+        CommonWidget,
+        CustomFont,
+        Enabled,
+        WidgetExtension
+{
+   /**
+    * Returns the current date time value as a character value.
+    * 
+    * @return   The current date time value as a character value
+    */
+   @LegacyAttribute(name = "DateTimeValue")
+   public character getDateTimeValue();
+   
+   /**
+    * Sets the current date value.
+    * 
+    * @param    value
+    *           The new current date value
+    */
+   @LegacyAttribute(name = "DateTimeValue", setter = true)
+   public void setDateTimeValue(date value);
+
+   /**
+    * Sets the current date and time value.
+    * 
+    * @param    value
+    *           The new current date and time value
+    */
+   @LegacyAttribute(name = "DateTimeValue", setter = true)
+   public void setDateTimeValue(datetime value);
+
+   /**
+    * Sets the current date and time value as a character value.
+    * 
+    * @param    value
+    *           The new current date and time value as a character value
+    */
+   @LegacyAttribute(name = "DateTimeValue", setter = true)
+   public void setDateTimeValue(character value);
+
+   /**
+    * Sets the current date and time value representing by a string.
+    * 
+    * @param    value
+    *           The new current date and time value representing by a string
+    */
+   @LegacyAttribute(name = "DateTimeValue", setter = true)
+   public void setDateTimeValue(String value);
+
+   /**
+    * Determines whether dates and times are displayed using standard or custom formatting.
+    * 
+    * @return   The date and time display format style constant.
+    */
+   @LegacyAttribute(name = "FormatStyle")
+   integer getFormatStyle();
+   
+   /**
+    * Determines whether dates and times are displayed using standard or custom formatting.
+    * 
+    * @param    formatStyle
+    *           The date and time display format style constant.
+    */
+   @LegacyAttribute(name = "FormatStyle", setter = true)
+   void setFormatStyle(integer formatStyle);
+   
+   /**
+    * Returns the background color used to display the month portion of the dropdown calendar.
+    * 
+    * @return   The background color for the dropdown calendar given by the BGR encoding
+    */
+   @LegacyAttribute(name = "CalendarBackColor")
+   integer getCalendarBackColor();
+   
+   /**
+    * Sets the background color used to display the month portion of the dropdown calendar.
+    * 
+    * @param    calendarBackColor
+    *           The background color for the dropdown calendar given by the BGR encoding
+    */
+   @LegacyAttribute(name = "CalendarBackColor", setter = true)
+   void setCalendarBackColor(integer calendarBackColor);
+   
+   /**
+    * Returns the foreground color used to display text in the month portion of the dropdown calendar.
+    * 
+    * @return   The foreground color for the dropdown calendar given by the BGR encoding
+    */
+   @LegacyAttribute(name = "CalendarForeColor")
+   integer getCalendarForeColor();
+   
+   /**
+    * Sets the foreground color used to display text in the month portion of the dropdown calendar.
+    * 
+    * @param    calendarForeColor
+    *           The foreground color for the dropdown calendar given by the BGR encoding
+    */
+   @LegacyAttribute(name = "CalendarForeColor", setter = true)
+   void setCalendarForeColor(integer calendarForeColor);
+   
+   /**
+    * Returns the background color used to display the title portion of the dropdown calendar.
+    * 
+    * @return   The background color for the title portion of the dropdown calendar given by
+    *           the BGR encoding.
+    */
+   @LegacyAttribute(name = "TitleBackColor")
+   integer getCalendarTitleBackColor();
+   
+   /**
+    * Sets the background color used to display the title portion of the dropdown calendar.
+    * 
+    * @param    titleBackColor
+    *           The background color for the title portion of the dropdown calendar given by
+    *           the BGR encoding.
+    */
+   @LegacyAttribute(name = "TitleBackColor", setter = true)
+   void setCalendarTitleBackColor(integer titleBackColor);
+   
+   /**
+    * Returns the foreground color used to display the title portion of the dropdown calendar.
+    * 
+    * @return   The foreground color for the title portion of the dropdown calendar given by
+    *           the BGR encoding.
+    */
+   @LegacyAttribute(name = "TitleForeColor")
+   integer getCalendarTitleForeColor();
+   
+   /**
+    * Sets the foreground color used to display the title portion of the dropdown calendar.
+    * 
+    * @param    titleForeColor
+    *           The foreground color for the title portion of the dropdown calendar given by
+    *           the BGR encoding.
+    */
+   @LegacyAttribute(name = "TitleForeColor", setter = true)
+   void setCalendarTitleForeColor(integer titleForeColor);
+   
+   /**
+    * Returns the foreground color used to display the days at the beginning and end of
+    * the dropdown calendar that are from previous and following months.
+    * 
+    * @return   The foreground color for the previous and following months of
+    *           the dropdown calendar given by the BGR encoding.
+    */
+   @LegacyAttribute(name = "TrailingForeColor")
+   integer getCalendarTrailingForeColor();
+   
+   /**
+    * Sets the foreground color used to display the days at the beginning and end of the dropdown
+    * calendar that are from previous and following months.
+    * 
+    * @param    trailingForeColor
+    *           The foreground color for the previous and following months of
+    *           the dropdown calendar given by the BGR encoding.
+    */
+   @LegacyAttribute(name = "TrailingForeColor", setter = true)
+   void setCalendarTrailingForeColor(integer trailingForeColor);
+   
+   /**
+    * Returns whether the control displays a checkbox to the left of the date. When unchecked,
+    * no date is selected.
+    * 
+    * @return   True if it displays a checkbox to the left of the date, otherwise false.
+    */
+   @LegacyAttribute(name = "CheckBox")
+   logical isCheckBox();
+   
+   /**
+    * Sets whether the control displays a checkbox to the left of the date. When unchecked,
+    * no date is selected.
+    * 
+    * @param    enabledCheckBox
+    *           The logical value indicating a checkbox is displayed or not.
+    */
+   @LegacyAttribute(name = "CheckBox", setter = true)
+   void setCheckBox(logical enabledCheckBox);
+   
+   /**
+    * Returns the custom format string used to format the date and/or time displayed
+    * in the control.
+    * 
+    * @return   The custom format string
+    */
+   @LegacyAttribute(name = "CustomFormat")
+   character getCustomFormat();
+   
+   /**
+    * Sets the custom format string used to format the date and/or time displayed in the control.
+    * 
+    * @param    customFormat
+    *           The custom format string
+    */
+   @LegacyAttribute(name = "CustomFormat", setter = true)
+   void setCustomFormat(character customFormat);
+   
+   /**
+    * Sets the custom format string used to format the date and/or time displayed in the control.
+    * 
+    * @param    customFormat
+    *           The custom format string
+    */
+   @LegacyAttribute(name = "CustomFormat", setter = true)
+   void setCustomFormat(String customFormat);
+   
+   /**
+    * Returns the day number [1-31] for the current date.
+    * 
+    * @return   The day number for the current date
+    */
+   integer getDay();
+   
+   /**
+    * Sets the day number [1-31] for the current date.
+    * 
+    * @param    day
+    *           The day number for the current date
+    */
+   void setDay(integer day);
+   
+   /**
+    * Returns the day of the week [0-6] for the current date.
+    * 
+    * @return   The day of the week for the current date
+    */
+   integer getDayOfWeek();
+   
+   /**
+    * Sets the day of the week [0-6] for the current date.
+    * 
+    * @param    dayOfWeek
+    *           The day of the week for the current date
+    */
+   void setDayOfWeek(integer dayOfWeek);
+   
+   /**
+    * Returns the hour number [0-23] for the current time.
+    * 
+    * @return   The hour number for the current time
+    */
+   integer getHour();
+   
+   /**
+    * Sets the hour number [0-23] for the current time.
+    * 
+    * @param    hour
+    *           The hour number for the current time
+    */
+   void setHour(integer hour);
+   
+   /**
+    * Returns the latest date that can be displayed or accepted by the control.
+    * 
+    * @return   The latest date that can be displayed or accepted by this control
+    */ 
+   date getMaxDate();
+   
+   /**
+    * Sets the latest date that can be displayed or accepted by the control.
+    * 
+    * @param    dateMaxDate
+    *           The new latest date
+    */
+   void setMaxDate(date dateMaxDate);
+   
+   /**
+    * Returns the earliest date that can be displayed or accepted by the control.
+    * 
+    * @return   The earliest date
+    */
+   date getMinDate();
+   
+   /**
+    * Sets the earliest date that can be displayed or accepted by the control.
+    * 
+    * @param    dateMinDate
+    *           The new earliest date
+    */
+   void setMinDate(date dateMinDate);
+   
+   /**
+    * Returns the minute number [0-59] for the current time.
+    * 
+    * @return   The minute number for the current time
+    */
+   integer getMinute();
+   
+   /**
+    * Sets the minute number [0-59] for the current time.
+    * 
+    * @param    minute
+    *           The minute number for the current time
+    */
+   void setMinute(integer minute);
+   
+   /**
+    * Returns the month number [1-12] for the current date.
+    * 
+    * @return   The month number for the current date
+    */
+   integer getMonth();
+   
+   /**
+    * Sets the month number [1-12] for the current date.
+    * 
+    * @param    month
+    *           The month number for the current date
+    */
+   void setMonth(integer month);
+   
+   /**
+    * Returns the second number [0-59] for the current time.
+    * 
+    * @return   The second number for the current time
+    */
+   integer getSecond();
+   
+   /**
+    * Sets the second number [0-59] for the current time.
+    * 
+    * @param    second
+    *           The second number for the current time
+    */
+   void setSecond(integer second);
+   
+   /**
+    * Returns a value that determines whether an updown (spin) button is used to modify dates
+    * instead of a dropdown calendar.
+    * 
+    * @return   True value if the updown spin button is used to modify dates instead of a dropdown
+    *           calendar, otherwise false value.
+    */
+   @LegacyAttribute(name = "UpDown")
+   logical isUpDown();
+
+   /**
+    * Sets a value that determines whether an updown (spin) buttons are used to modify dates
+    * instead of a dropdown calendar.
+    * 
+    * @param    upDown
+    *           The logical value indicating if the up and down buttons are used to modify dates
+    */
+   @LegacyAttribute(name = "UpDown", setter = true)
+   void setUpDown(logical upDown);
+   
+   /**
+    * Returns the year for the current date.
+    * 
+    * @return   The year for the current date
+    */
+   integer getYear();
+   
+   /**
+    * Sets the year for the current date.
+    * 
+    * @param    year
+    *           The year for the current date
+    */
+   void setYear(integer year);
+}

